︠9422c217-6954-415c-8a6a-e3e63f38f5dai︠
%html
<p>The trapezoid approximation: $f$ is the function, $[a,b]$ the interval, $k$ the number of subintervals.</p>

︡c37aeb66-33b3-44f5-957d-1a089a57e8f0︡{"html": "<p>The trapezoid approximation: $f$ is the function, $[a,b]$ the interval, $k$ the number of subintervals.</p>"}︡
︠81791b3f-57f3-4cab-acb2-ab7900a26bee︠
def trapezoid(f, a, b, k):
    sum = 0;
    for i in range(k+1):
        x = a + (b - a)*i/k;
        y = f(x);
        if (i == 0 or i == k):
            y = y/2;
        sum += y;
    sum = sum * (b-a) / k
    return sum
︡a5317d71-64f8-41de-8d77-3fdd6b088755︡︡
︠5a0533c8-a234-4eb9-9814-c102f53e8439i︠
%html
<p>The trapezoid error: $M$ is an upper bound on the second derivative of $f$.</p>

︡cfb8488e-ed6b-4fc3-ac74-996a34c4aa18︡{"html": "<p>The trapezoid error: $M$ is an upper bound on the second derivative of $f$.</p>"}︡
︠fa2a263c-68bd-4b02-8a02-549a8d3b616f︠
def trapezoid_error(M,a,b,k):
    return M*(b-a)^3/12/k^2
︡ffbb2644-60b2-482f-84d7-67096d63ad82︡︡
︠b1008966-938e-4c4d-ad08-dee8388bb12ai︠
%html
<p>An example: Let $f=e^{-x^2}$, on the interval $[0,1]$.</p>

︡9f50158d-9541-44ae-ae6c-09660466cfb3︡{"html": "<p>An example: Let $f=e^{-x^2}$, on the interval $[0,1]$.</p>"}︡
︠022bfe07-8956-4748-b0db-ef3e171e8a6b︠
f(x)=exp(-x^2); x0=0; x1=1;
︡bf7a57f9-27ed-4c1d-829d-b27634706cad︡︡
︠6a75378c-dce3-4722-b113-659fd106c07ei︠
%html
<p><span style="font-size: medium;">Compute and plot the second derivative to find the maximum value of $|f^{(2)}|$.</span></p>

︡6e126359-f453-4d45-8883-c63a28d8942a︡{"html": "<p><span style=\"font-size: medium;\">Compute and plot the second derivative to find the maximum value of $|f^{(2)}|$.</span></p>"}︡
︠7b231f5d-30f0-41ee-b8d0-1e990dcae5f7︠
fpp=diff(f,x,2); plot(fpp,x0,x1)
︡a01bf70a-6cc2-424b-a792-23902611b6f7︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠6b1c9be3-2ced-4a19-8bc2-01c3c2db9450i︠
%html
<p>So the maximum appears to be 2. Now compute the approximation until the error is small; try increasing $j$ until the two values $A-E$ and $A+E$ round to the same value to two decimal places.</p>

︡f0a59e4e-bf7e-4068-bb7c-e72fd1cc8955︡{"html": "<p>So the maximum appears to be 2. Now compute the approximation until the error is small; try increasing $j$ until the two values $A-E$ and $A+E$ round to the same value to two decimal places.</p>"}︡
︠324daca3-c9d2-49de-a0f7-3bef348b940e︠
j=6; A=n(trapezoid(f,x0,x1,j)); E=n(trapezoid_error(2,x0,x1,j)); A; E; A-E; A+E;
︡a13d866a-1704-4442-bb09-bd17cfe58db3︡{"stdout": "0.745119412436179\n0.00462962962962963\n0.740489782806550\n0.749749042065809"}︡
︠c4deef2b-9e07-4491-ba72-9966ce90048ci︠
%html
<p>The Simpson's rule function and error computation are similar. You must put in an even number for $k$; the function doesn't check for this.</p>

︡4d394fe8-f46a-4297-9acf-7957aad69a7c︡{"html": "<p>The Simpson's rule function and error computation are similar. You must put in an even number for $k$; the function doesn't check for this.</p>"}︡
︠6e5b6a46-07cd-4a33-b19b-e6503f895b5a︠
def simpson(f, a, b, k):
    sum = 0;
    for i in range(k+1):
        x = a + (b - a)*i/k;
        y = f(x);
        if (i > 0 and i < k):
            y = 2*(i%2+1)*y
        sum += y;
    sum = sum * (b-a) / k /3
    return sum
︡33689fcd-bb46-4cba-bf36-3e964f6989b6︡︡
︠b1e66ae4-82aa-4397-b564-43c0342526c3︠
def simpson_error(M,a,b,k):
    return M*(b-a)^5/180/k^4
︡428c894b-d3d3-4095-80d0-db167485898d︡︡
︠f4cdef92-1306-4131-86d1-c7c1f96d910a︠
f4p=diff(f,x,4); plot(f4p,x0,x1)
︡f057f948-3a60-4c29-be39-4c59d2884ef2︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠6f86e596-d149-48c1-94a0-36f5d18aeb2ci︠
%html
<p>The maximum value of $|f^{(4)}|$ appears to be 12.</p>

︡2e706df2-641f-40a0-9ad3-56debf8878db︡{"html": "<p>The maximum value of $|f^{(4)}|$ appears to be 12.</p>"}︡
︠32edbfd3-274b-4e72-97f2-e218223e05ed︠
j=4; A=n(simpson(f,x0,x1,j)); E=n(simpson_error(12,x0,x1,j)); A; E; A-E; A+E;
︡c6ca42f7-6b82-4c63-972b-4d00fb438d76︡{"stdout": "0.746855379790987\n0.000260416666666667\n0.746594963124320\n0.747115796457654"}︡
︠0f591821-dc6e-4406-a2a4-c13050d36aeci︠
%html
<p>Let's see what Sage thinks the value is.</p>

︡8e3bf03c-a5eb-4034-80e9-5a52d5d97392︡{"html": "<p>Let's see what Sage thinks the value is.</p>"}︡
︠e650d830-1513-425a-a5c1-f7e69c4e0fb0︠
n(integral(f,x,x0,x1))
︡4532799c-1932-4597-9fe6-e09f68ce3694︡{"stdout": "0.746824132812427"}︡
